using System;
using System.Security.Principal;
using System.Security.Permissions;

class RoleBasedSecurityDemo
{
	static void Main()
	{
		Console.Write("Username: ");
		string user = Console.ReadLine();
		Console.Write("Password: ");
		string pass = Console.ReadLine();

		if (ValidLogin(user, pass))
		{
			// Create generic identity and principal objects
			GenericIdentity identity = new GenericIdentity(user);
			string[] roles = {"Manager", "Developer", "QA"};
			GenericPrincipal principal =
				new GenericPrincipal(identity, roles);

			// Attach the principal to the current thread
			System.Threading.Thread.CurrentPrincipal = principal;

			DoSecuredOpearation();
		}
		else
		{
			Console.WriteLine("Invalid login.");
		}
	}

	static bool ValidLogin(string aUsername, string aPassword)
	{
		bool valid = (aUsername == aPassword);
		return valid;
	}

	[PrincipalPermission(SecurityAction.Demand, Name="Admin")]
	static void DoSecuredOpearation()
	{
		Console.WriteLine("Secure opration invoked.");
		IPrincipal principal = System.Threading.Thread.CurrentPrincipal;
		Console.WriteLine("User: {0}", principal.Identity.Name);

		bool isManager = principal.IsInRole("Manager");
		Console.WriteLine("Is Manager: {0}", isManager);

		bool isGod = principal.IsInRole("God");
		Console.WriteLine("Is God: {0}", isGod);
	}
}
